using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace Forum
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.CheckBox checkBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(24, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(360, 240);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(32, 280);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(200, 24);
			this.checkBox1.TabIndex = 1;
			this.checkBox1.Text = "Hide the first grand child row";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 310);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.IndentHierarchies = true;
			
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
			DataTable grandChildTable = GetGrandChildTable(); 
			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable, grandChildTable}); 
			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			DataRelation childToGrandChild = new DataRelation("ChildToGrandChild", childTable.Columns["childID"], grandChildTable.Columns["ChildID"]); 
			ds.Relations.AddRange(new DataRelation[]{parentToChild, childToGrandChild });

			this.gridDataBoundGrid1.DataSource = ds;
			this.gridDataBoundGrid1.DataMember = parentTable.TableName; 
			GridHierarchyLevel level0 = this.gridDataBoundGrid1.Binder.RootHierarchyLevel;
			GridHierarchyLevel level1 = this.gridDataBoundGrid1.Binder.AddRelation("ParentToChild");
			GridHierarchyLevel level2 = this.gridDataBoundGrid1.Binder.AddRelation("ChildToGrandChild");

			this.gridDataBoundGrid1.Model.Rows.HeaderCount += 1;
			this.gridDataBoundGrid1.Model.Rows.FrozenCount = this.gridDataBoundGrid1.Model.Rows.HeaderCount;
			this.gridDataBoundGrid1.Model.CoveredRanges.Add(GridRangeInfo.Cells(this.gridDataBoundGrid1.Model.Rows.HeaderCount,2,this.gridDataBoundGrid1.Model.Rows.HeaderCount,this.gridDataBoundGrid1.Model.ColCount));
			this.gridDataBoundGrid1.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(gridDataBoundGrid1_PrepareViewStyleInfo);
			this.gridDataBoundGrid1.CellButtonClicked += new GridCellButtonClickedEventHandler(gridDataBoundGrid1_CellButtonClicked);
		}

		# region Datatable
		private int numberParentRows = 10;
		private int numberChildRows = 20;
		private int numberGrandChildRows = 50;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable"); 

			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec")); 
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			} 
			return dt;
		} 
		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable"); 
			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P

			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dt.Rows.Add(dr);
			}

			return dt;
		} 
		private DataTable GetGrandChildTable()
		{
			DataTable dt = new DataTable("GrandChildTable"); 
			dt.Columns.Add(new DataColumn("GrandChildID"));
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ChildID")); //upper case C

			for(int i = 0; i < numberGrandChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("GrandChildName{0}",i);
				dr[2] = (i % numberChildRows).ToString();
				dt.Rows.Add(dr);
			}

			return dt;
		}
		# endregion

		private void gridDataBoundGrid1_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
			if(e.ColIndex == 2 && e.RowIndex == this.gridDataBoundGrid1.Model.Rows.HeaderCount)// On the new header
			{
				e.Style.FloatCell = true;
				e.Style.Text = RowCounts();
				e.Style.BackColor = Color.Goldenrod;
			}
		}
		private string RowCounts()
		{
			if((this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(RowIndex)).HasChildList)
				return (this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(RowIndex)).ChildCount + " ChildRows " +"& " +  VisibleRowCount()+ " TotalRows";
			else
				return VisibleRowCount() + " TotalRows";
		}
		int RowIndex;
		private void gridDataBoundGrid1_CellButtonClicked(object sender, Syncfusion.Windows.Forms.Grid.GridCellButtonClickedEventArgs e)
		{
			RowIndex = e.RowIndex;
			this.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(GridRangeInfo.Cols(1,3));
			this.gridDataBoundGrid1.RefreshRange(GridRangeInfo.Cells(this.gridDataBoundGrid1.Model.Rows.HeaderCount,2,this.gridDataBoundGrid1.Model.Rows.HeaderCount,this.gridDataBoundGrid1.Model.ColCount));
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			if(checkBox1.Checked)
			{
				for(int i = gridDataBoundGrid1.Model.Rows.HeaderCount+1; i<this.gridDataBoundGrid1.Model.RowCount; i++)
				{
					GridBoundRecordState rs = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(i);
					if( rs.LevelIndex == 1 && rs.HasChildList )
					{
						// as an example only the first grand child row is hidden
						this.gridDataBoundGrid1.Model.Rows.Hidden[i+1] = true;
						Console.WriteLine(i+1);
						this.gridDataBoundGrid1.Refresh();
					}
				}
			}
			else
			{
				for(int i = 0; i<this.gridDataBoundGrid1.Model.RowCount; i++)
					this.gridDataBoundGrid1.Model.Rows.Hidden[i] = false;
			}
			this.gridDataBoundGrid1.RefreshRange(GridRangeInfo.Cells(this.gridDataBoundGrid1.Model.Rows.HeaderCount,2,this.gridDataBoundGrid1.Model.Rows.HeaderCount,this.gridDataBoundGrid1.Model.ColCount));
		}

		private int VisibleRowCount()
		{
			int Count = 0;
			for(int i=gridDataBoundGrid1.Model.Rows.HeaderCount+1; i<=this.gridDataBoundGrid1.Model.RowCount; i++)
				if(this.gridDataBoundGrid1.Model.Rows.Hidden[i] == false)
					Count++;
			return Count;
		} 
	}
}
